#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include "forms.h"

#include "Xsoxdefs.h"

extern FD_Xsox *fd_xsox;
extern FD_Effects *fd_effects;

void Effects(FL_OBJECT *ob, long data)
{
   fl_show_form(fd_effects->Effects,FL_PLACE_CENTER,
		FL_FULLBORDER,"Sound Effects");
}

void CloseEffects(FL_OBJECT *ob, long data)
{
   fl_hide_form(fd_effects->Effects);
}

void SetPlain(FL_OBJECT *ob, long data)
{  /* unset all efffect buttons ! */
   fl_set_button(fd_effects->Echo,0);
   fl_set_button(fd_effects->Vibro,0);
   fl_set_button(fd_effects->LowPass,0);
   fl_set_button(fd_effects->HighPass,0);
   fl_set_button(fd_effects->BandPass,0);
   fl_set_button(fd_effects->Plain,1);
}

void UnsetPlain(FL_OBJECT *ob, long data)
{
    fl_set_button(fd_effects->Plain,0);
}

int AddEcho(int output)
{  char echocmd[MAXSTRING];
   char *sndtype = GetOutputType();
   int newoutput;
   
   sprintf(echocmd,"sox -t %s - -t %s - echo %.3f %.3f ",
	   sndtype,sndtype,
	   (double)fl_get_slider_value(fd_effects->EchoDelay),
	   fl_get_slider_value(fd_effects->EchoVolume));
   
   newoutput = ForkCommand(echocmd,output,INPUTREDIR | OUTPUTREDIR);
   return newoutput;
}

int AddVibro(int output)
{  char vibrocmd[MAXSTRING];
   char *sndtype = GetOutputType();
   int newoutput;

   sprintf(vibrocmd,"sox -t %s - -t %s - vibro %.0f %.3f ",
	   sndtype,sndtype,
	   fl_get_slider_value(fd_effects->VibroSpeed),
	   fl_get_slider_value(fd_effects->VibroDepth));
   
   newoutput = ForkCommand(vibrocmd,output,INPUTREDIR | OUTPUTREDIR);
   close(output);
   return newoutput;
}

int AddLowPassFilter(int output)
{  char lowpasscmd[MAXSTRING];
   char *sndtype = GetOutputType();
   int newoutput;

   sprintf(lowpasscmd,"sox -t %s - -t %s - lowp %.0f ",
	   sndtype,sndtype,
	   fl_get_slider_value(fd_effects->FilterFrequency) * 1000);

   newoutput = ForkCommand(lowpasscmd,output,INPUTREDIR | OUTPUTREDIR);
   return newoutput;
}

int AddHighPassFilter(int output)
{  char highpasscmd[MAXSTRING];
   char *sndtype = GetOutputType();
   int newoutput;

   sprintf(highpasscmd,"sox -t %s - -t %s - highp %.0f ",
	   sndtype,sndtype,
	   fl_get_slider_value(fd_effects->FilterFrequency) * 1000);

   newoutput = ForkCommand(highpasscmd,output,INPUTREDIR | OUTPUTREDIR);
   return newoutput;
}

int AddBandPassFilter(int output)
{  char bandpasscmd[MAXSTRING];
   char *sndtype = GetOutputType();
   int newoutput;

   sprintf(bandpasscmd,"sox -t %s - -t %s - band %.0f %.0f ",
	   sndtype,sndtype,
	   fl_get_slider_value(fd_effects->FilterFrequency) * 1000,
	   fl_get_slider_value(fd_effects->Bandwidth) * 1000);

   newoutput = ForkCommand(bandpasscmd,output,INPUTREDIR | OUTPUTREDIR);
   return newoutput;
}

int AddEffects(int output)
{   
   int newoutput=output;

   if(fl_get_button(fd_effects->Echo))
     newoutput=AddEcho(newoutput);
   if(fl_get_button(fd_effects->Vibro))
      newoutput=AddVibro(newoutput);
   if(fl_get_button(fd_effects->LowPass))
      newoutput=AddLowPassFilter(newoutput);
   if(fl_get_button(fd_effects->HighPass))
      newoutput=AddHighPassFilter(newoutput);
   if(fl_get_button(fd_effects->BandPass))
      newoutput=AddBandPassFilter(newoutput);

   return newoutput;
}

void AddAmplification(char *cmd)
{
   sprintf(cmd + strlen(cmd),"-v %.3f ",
	   fl_get_slider_value(fd_effects->Amplification));
}
